-- Create database
CREATE DATABASE ExagoDemoApp

CREATE TABLE UserClasses
	(
    	id INT NOT NULL IDENTITY PRIMARY KEY,
    	name VARCHAR(50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
	)

CREATE TABLE Reports
	(
    	id INT NOT NULL IDENTITY PRIMARY KEY,
    	name VARCHAR(100) COLLATE SQL_Latin1_General_CP1_CI_AS,
    	content VARCHAR(MAX) COLLATE SQL_Latin1_General_CP1_CI_AS,
    	leaf_flag BIT,
    	bit_content VARBINARY(MAX),
    	type INT,
    	isDeleted BIT,
    	themeType VARCHAR(10) COLLATE SQL_Latin1_General_CP1_CI_AS,
    	parentId INT,
    	dateCreated DATETIME2,
    	createdByUserId VARCHAR(50) COLLATE SQL_Latin1_General_CP1_CI_AS,
    	dateLastModified DATETIME2,
    	lastModifiedByUserId VARCHAR(50) COLLATE SQL_Latin1_General_CP1_CI_AS
	)

CREATE TABLE ReportAccessUser
	(
    	userId NVARCHAR(128) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
    	reportId INT NOT NULL,
    	readonly_flag BIT DEFAULT 0 NOT NULL,
		PRIMARY KEY(userId, reportId),
		CONSTRAINT fk_rau_reportId FOREIGN KEY (reportId) REFERENCES Reports (id)
	)


CREATE TABLE ReportAccessUserClasses
	(
    	userClassId INT NOT NULL,
    	reportId INT NOT NULL,
    	readonly_flag BIT DEFAULT 0 NOT NULL,
		PRIMARY KEY(userClassId, reportId),
		CONSTRAINT fk_rauc_userClassId FOREIGN KEY (userClassId) REFERENCES UserClasses (id),
		CONSTRAINT fk_rauc_reportId FOREIGN KEY (reportId) REFERENCES Reports (id)
	)
 
CREATE TABLE ReportPublished
	(
    	reportId INT NOT NULL PRIMARY KEY,
    	readonly_flag BIT,
		CONSTRAINT fk_rp_reportId FOREIGN KEY (reportId) REFERENCES Reports (id)
	)
 
CREATE TABLE Companies
	(
    	id INT NOT NULL IDENTITY PRIMARY KEY,
    	name VARCHAR(50) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL
	)
 
CREATE TABLE UserSettings
	(
    	userId NVARCHAR(128) COLLATE SQL_Latin1_General_CP1_CI_AS NOT NULL,
    	companyId INT NOT NULL,
    	classId INT NOT NULL,
		PRIMARY KEY(userId, companyId),
		CONSTRAINT fk_us_companyId FOREIGN KEY (companyId) REFERENCES Companies (id),
		CONSTRAINT fk_us_classId FOREIGN KEY (classId) REFERENCES UserClasses (id),
	)

